import itertools
import math
def calculate_distance(point1, point2):
    return math.sqrt((point1[0] - point2[0])**2 + (point1[1] - point2[1])**2)
def total_distance(route):
    distance = 0
    for i in range(len(route) - 1):
        distance += calculate_distance(route[i], route[i + 1])
    return distance
def find_shortest_route(points):
    min_distance = float('inf')
    shortest_route = None
    for perm in itertools.permutations(points):
        current_distance = total_distance(perm)
        if current_distance < min_distance:
            min_distance = current_distance
            shortest_route = perm
    return shortest_route, min_distance
n = int(input())
points = []
for _ in range(n):
    x, y = map(int, input().split())
    points.append((x, y))
shortest_route, min_distance = find_shortest_route(points)
print( min_distance)