import itertools
import math


def distance(p1, p2):
    return math.sqrt((p1[0] - p2[0]) **2 + (p1[1] - p2[1]) **2)


def tsp(points):
    if len(points) == 1:
        return 0

    dist = {(i, j): distance(points[i], points[j]) for i in range(len(points)) for j in range(len(points)) if i != j}

    min_path = float('inf')
    for path in itertools.permutations(range(len(points))):
        path_length = 0
        for i in range(1, len(path)):
            path_length += dist[(path[i - 1], path[i])]
        min_path = min(min_path, path_length)

    return min_path


n = int(input())
points = [list(map(int, input().split())) for _ in range(n)]

print(f"{tsp(points)}")